var {
  ExtensionCommon
} = ChromeUtils.import("resource://gre/modules/ExtensionCommon.jsm");
var {
  Services
} = ChromeUtils.import("resource://gre/modules/Services.jsm");

//Define API
var maxMsgPaneApi = class extends ExtensionCommon.ExtensionAPI {
  getAPI(context) {
    return {
      maxMsgPaneApi: {
        setFocusThreadPane: async function () {
          let rw = Services.wm.getMostRecentWindow("mail:3pane");
          if (rw) {
            let folderTree = rw.document.getElementById("folderTree");
            if (rw.gFolderDisplay.focusedPane == folderTree) rw.SetFocusThreadPane();
          }
        },

        collapse: async function (elementID, collapse) {
          let rw = Services.wm.getMostRecentWindow("mail:3pane");
          let ret = false; //state was changed or not
          if (rw) {
            let elem = rw.document.getElementById(elementID);
            if (elem) {
              let org = elem.collapsed ? true : false;
              if (collapse) {
                elem.collapsed = true;
              } else {
                elem.collapsed = false;
              }
              
              ret = (org != elem.collapsed);
            }
            //sync Lightning's elements
            if (elementID == "today-pane-panel") {
              let ltnToday = rw.document.getElementById("today-pane-panel");
              let ltnTodaySplit = rw.document.getElementById("today-splitter");
              if (ltnToday) {
                if (ltnToday.collapsed) {
                  if (ltnTodaySplit) ltnTodaySplit.setAttribute("state", "collapsed");
                } else {
                  if (ltnTodaySplit) ltnTodaySplit.removeAttribute("state");
                }
              }
            }
          }
          return ret;
        },

        isCollapsed: async function (elementID) {
          let rw = Services.wm.getMostRecentWindow("mail:3pane");
          let ret = false;
          if (rw) {
            let elem = rw.document.getElementById(elementID);
            if (elem && elem.collapsed) {
              ret = true;
            } else {
              ret = false;
            }
          }

          return ret;
        },

        setFlex: async function (elementID, flex) {
          let rw = Services.wm.getMostRecentWindow("mail:3pane");
          if (rw) {
            let elem = rw.document.getElementById(elementID);
            if (elem) {
              elem.flex = flex;
            }
          }
        }
      }
    };
  }
};
